	PROGRAM KURVE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CP
CP	PROGRAM FOR KURVETILPASNING TIL EN VILK]RLIG FUNKSJON
CP
CP	Y(I)=F(X(I);A(1),...,A(N))
CP
CP	HVOR A(I) ER INNTIL 6 UAVHENGIGE TILPASNINGSKONSTANTER
CP	FUNKSJONEN OG DENS DERIVERTE MHP. A(I) SPESIFISERES I
CP	SUBROUTINEN FUNK SOM STATEMENTENE F= OG FD(I)= .
CP	DATASETTET SOM SKAL TILPASSES HENTES FRA DATAFIL INN.DAT
CP
CP	P.]. Krogstad 1987
CP
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	PARAMETER(NDMAX=150)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        COMMON/BL15/ H(6,6),B(6),DA(6)
        COMMON/F/ F,FD(6),A(6)
	DIMENSION X(NDMAX),Y(NDMAX)
CP
CP	Innlesning av datasettet som skal tilpasses:
CP
	KMAX=6
	OPEN(1,FILE='INN.DAT',STATUS='OLD')
        OPEN(9,FILE='KURVE.PLT')
	READ(1,*) KK
	READ(1,*) (A(I),I=1,KK)
	I=1
10	READ(1,*,END=100) X(I),Y(I)
	I=I+1
	GOTO 10
100	N=I-1
	CLOSE(1)
CP
CP	Konstruerer tilpasningsmatrise ved hjelp av funksjonen
CP	som er spesifisert i SUBROUTINE FUNK
CP
	   OPEN(1,FILE='KURVE.DAT',STATUS='UNKNOWN')
       OPEN(231,FILE='KURVE_OUT.DAT',STATUS='REPLACE')
	ITR=1
	ITRLIM=20
	EPSIL=1.E-5
105	DO 102 J=1,KMAX
	DO 101 K=1,KMAX
101	H(J,K)=0.
102	B(J)=0.
	DO 110 I=1,N
	CALL FUNK(X(I),KK,ITR)
	IF(KK.GT.KMAX) GOTO 970
	DO 110 J=1,KK
	DO 111 K=1,KK
111	H(J,K)=H(J,K)+FD(J)*FD(K)
110	B(J)=B(J)-(F-Y(I))*FD(J)
	CALL INVERS(KK)
CP
CP	Itererer konstantene A(I) inntil ITRLIM ganger og
CP	kontrollerer mot konvergenskriteriet EPSLIM.
CP
	DEL=0.
	DO 120 K=1,KK
	Z=ABS(DA(K)/A(K))
	IF(Z.GT.DEL) DEL=Z
120	A(K)=A(K)+DA(K)
	IF(ITR.GE.ITRLIM) GOTO 900
	ITR=ITR+1
	IF(DEL.GT.EPSIL) GOTO 105
	ITR=ITR-1
	WRITE(*,200) ITR
	WRITE(1,200) ITR
200	FORMAT(/,4X,'Dataset fitted after',I3,' iterations.'//
    //,4X,'Coefficients of fourth order polynomial:',/)
     	DO 205 K=1,KK
        WRITE(1,210) K,A(K)        
        WRITE(231,'(F14.7)') A(K)
205    	WRITE(*,210) K,A(K)
210	FORMAT(4X,'A(',I1,')=',1PE12.4)
	WRITE(1,220)
!	WRITE(*,220)
220	FORMAT(/' Tilpasning:'/
     ,/'        x        y(data)      y(tilpasning)')
	DEL=0.
	DO 230 I=1,N
	CALL FUNK(X(I),KK,2)
	DEL=DEL+ABS(2.*(Y(I)-F)/(Y(I)+F))
	WRITE(1,240) X(I),Y(I),F
235     FORMAT(3F12.4)
230    WRITE(9,235)X(I),Y(I),F
!230	WRITE(*,240) X(I),Y(I),F
240	FORMAT(1P3E13.3)
	DEL=DEL/N
	WRITE(1,250) DEL
	WRITE(*,250) DEL
250	FORMAT(/,4x,'Average relative deviation:',1PE12.4)
	GOTO 950
900	WRITE(*,910) ITR
910	FORMAT(//' Ingen konvergens etter',I2,' iterasjoner'/
     ,/' Bruk en annen funksjon eller bedre estimerte',
     ,' initialverdier for A(I) ***')
	GOTO 950
970	WRITE(*,975) KMAX
975	FORMAT(' !!! NB! MAX ',I2,' KONSTANTER TILLATT !!!')
950    	CONTINUE
	CLOSE(1)
    	CLOSE(231)
      
	END
	
	

	SUBROUTINE FUNK(X,N,ITR)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        COMMON/F/ F,FD(6),A(6)
CP	I denne rutinen spesifiseres funksjonen som skal tilpasses
CP	datasettet samt funksjonens deriverte mhp tilpasningskonstantene.
CP
CP	N=antall tilpasningskonstanter i funksjonen.
CP
CP	Hvis det |nskes tilpasning til et 2.gradspolynom blir rutinen:
CP	N=3
CP	F=A(1)+A(2)*X+A(3)*X*X
CP	FD(1)=1.
CP	FD(2)=X
CP	FD(3)=X*X
CP
CP####  NB! Husk } sette rimelige initialdata for A(I).  ####
CP
	F=A(1)+A(2)*X+A(3)*X*X+A(4)*X*X*X !+A(5)*X*X*X*X
	FD(1)=1.
	FD(2)=X
	FD(3)=X*X
    	FD(4)=X*X*X
    	!FD(5)=X*X*X*X
        
	RETURN
	END
	
        SUBROUTINE INVERS(NP)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CJ      THIS ROUTINE CALCULATES THE INVERSE OF THE INFLUENCE    CC
CJ      MATRIX,AND SOLVES THE SYSTEM OF LINEAR  EQUATIONS BY    CC
CJ      THE MULTIPLICATION : SOR=F(INV)*H                       CC
CJ      J. HANSSEN  1987                                        CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
 
        IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        COMMON/BL15/ F(6,6),H(6),SOR(6)
	DIMENSION O(6,6),FINV(6,6)
        EPS=1.0D-6
 
C       CONVERTING F(6,6) TO A TWO-DIMENSIONAL MATRIX: O(I,J),
C       WICH IS TO BE INVERTED
 
        DO 1 I=1,NP
        DO 2 J=1,NP
        O(I,J)=F(I,J)
2       CONTINUE
1       CONTINUE
 
C       CONSTRUCT IDENTITY MATRIX  FINV(I,J)=I
 
        DO 6 I=1,NP
        DO 5 J=1,NP
        IF (I-J) 4,3,4
3       FINV(I,J)=1.0
        GO TO 5
4       FINV(I,J)=0.0
5       CONTINUE
6       CONTINUE
 
C       LOCATE MAXIMUM MAGNITUDE O(I,K) ON OR BELOW MAIN DIAGONAL
 
        SDEL=1.0
        DO 45 K=1,NP
        IF (K-NP) 12,30,30
12      IMAX=K
        AMAX=DABS(O(K,K))
        KP1=K+1
        DO 20 I=KP1,NP
        IF (AMAX-DABS(O(I,K))) 15,20,20
15      IMAX=I
        AMAX=DABS(O(I,K))
20      CONTINUE
 
C       INTERCHANGE ROWS IMAX AND K IF IMAX NOT EQUAL TO K
 
        IF (IMAX-K) 25,30,25
25      DO 29 J=1,NP
        ATMP=O(IMAX,J)
        O(IMAX,J)=O(K,J)
        O(K,J)=ATMP
        BTMP=FINV(IMAX,J)
        FINV(IMAX,J)=FINV(K,J)
29      FINV(K,J)=BTMP
        SDEL=-SDEL
30      CONTINUE
 
C       TEST FOR SINGULAR OR NEAR SINGULAR MATRIX.
 
        IF (DABS(O(K,K))-EPS) 93,93,35
99      STOP
93      WRITE(*,78)
78	FORMAT('SINGULAR MATRIX')
        GO TO 99
35      SDEL=O(K,K)*SDEL
 
C       DIVIDE PIVOT ROW BY ITS MAIN DIAGONAL ELEMENT.
 
        DIV=O(K,K)
        DO 38 J=1,NP
        O(K,J)=O(K,J)/DIV
38      FINV(K,J)=FINV(K,J)/DIV
 
C       REPLACE EACH ROW BY LINEAR COMB. WITH PIVOT ROW
 
        DO 43 I=1,NP
        AMULT=O(I,K)
        IF (I-K) 39,43,39
39      DO 42 J=1,NP
        O(I,J)=O(I,J)-AMULT*O(K,J)
42      FINV(I,J)=FINV(I,J)-AMULT*FINV(K,J)
43      CONTINUE
45      CONTINUE

C       COMPUTE SOR=FINV*H
 
        DO 50 I=1,NP
         SOR(I)=0.0
         DO 51 K=1,NP
         SOR(I)=SOR(I)+FINV(I,K)*H(K)
51       CONTINUE
50      CONTINUE
        RETURN
        END 
